searchNodes=[{"ref":"GoogleApi.HomeGraph.V1.Api.AgentUsers.html","title":"GoogleApi.HomeGraph.V1.Api.AgentUsers","type":"module","doc":"API calls for all endpoints tagged AgentUsers."},{"ref":"GoogleApi.HomeGraph.V1.Api.AgentUsers.html#homegraph_agent_users_delete/4","title":"GoogleApi.HomeGraph.V1.Api.AgentUsers.homegraph_agent_users_delete/4","type":"function","doc":"Unlinks an agent user from Google. As a result, all data related to this user will be deleted. Here is how the agent user is created in Google: When a user opens their Google Home App, they can begin linking a 3p partner. User is guided through the OAuth process. After entering the 3p credentials, Google gets the 3p OAuth token and uses it to make a Sync call to the 3p partner and gets back all of the user&#39;s data, including agent_user_id and devices. Google creates the agent user and stores a mapping from the agent_user_id -&gt; Google ID mapping. Google also stores all of the user&#39;s devices under that Google ID. The mapping from agent_user_id to Google ID is many to many, since one Google user can have multiple 3p accounts, and multiple Google users can map to one agent_user_id (e.g., a husband and wife share one Nest account username/password). The third-party user&#39;s identity is passed in as agent_user_id. The agent is identified by the JWT signed by the partner&#39;s service account. Note: Special characters (except &quot;/&quot;) in agent_user_id must be URL-encoded. Parameters connection (type: GoogleApi.HomeGraph.V1.Connection.t) - Connection to server agent_users_id (type: String.t) - Part of agentUserId. Required. Third-party user ID. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :requestId (type: String.t) - Request ID used for debugging. opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.HomeGraph.V1.Model.Empty{}} on success {:error, info} on failure"},{"ref":"GoogleApi.HomeGraph.V1.Api.Devices.html","title":"GoogleApi.HomeGraph.V1.Api.Devices","type":"module","doc":"API calls for all endpoints tagged Devices."},{"ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_query/3","title":"GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_query/3","type":"function","doc":"Gets the device states for the devices in QueryRequest. The third-party user&#39;s identity is passed in as agent_user_id. The agent is identified by the JWT signed by the third-party partner&#39;s service account. Parameters connection (type: GoogleApi.HomeGraph.V1.Connection.t) - Connection to server optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.HomeGraph.V1.Model.QueryRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.HomeGraph.V1.Model.QueryResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_report_state_and_notification/3","title":"GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_report_state_and_notification/3","type":"function","doc":"Reports device state and optionally sends device notifications. Called by an agent when the device state of a third-party changes or the agent wants to send a notification about the device. See Implement Report State for more information. This method updates a predefined set of states for a device, which all devices have according to their prescribed traits (for example, a light will have the OnOff trait that reports the state on as a boolean value). A new state may not be created and an INVALID_ARGUMENT code will be thrown if so. It also optionally takes in a list of Notifications that may be created, which are associated to this state change. The third-party user&#39;s identity is passed in as agent_user_id. The agent is identified by the JWT signed by the partner&#39;s service account. Parameters connection (type: GoogleApi.HomeGraph.V1.Connection.t) - Connection to server optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_request_sync/3","title":"GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_request_sync/3","type":"function","doc":"Requests a SYNC call from Google to a 3p partner&#39;s home control agent for a user. The third-party user&#39;s identity is passed in as agent_user_id (see RequestSyncDevicesRequest) and forwarded back to the agent. The agent is identified by the API key or JWT signed by the partner&#39;s service account. Parameters connection (type: GoogleApi.HomeGraph.V1.Connection.t) - Connection to server optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.HomeGraph.V1.Api.Devices.html#homegraph_devices_sync/3","title":"GoogleApi.HomeGraph.V1.Api.Devices.homegraph_devices_sync/3","type":"function","doc":"Gets all the devices associated with the given third-party user. The third-party user&#39;s identity is passed in as agent_user_id. The agent is identified by the JWT signed by the third-party partner&#39;s service account. Parameters connection (type: GoogleApi.HomeGraph.V1.Connection.t) - Connection to server optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.HomeGraph.V1.Model.SyncRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.HomeGraph.V1.Model.SyncResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html","title":"GoogleApi.HomeGraph.V1.Connection","type":"module","doc":"Handle Tesla connections for GoogleApi.HomeGraph.V1."},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#delete/3","title":"GoogleApi.HomeGraph.V1.Connection.delete/3","type":"function","doc":"Perform a DELETE request. See request/1 or request/2 for options definition. delete(&quot;/users&quot;) delete(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete(client, &quot;/users&quot;) delete(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#delete!/3","title":"GoogleApi.HomeGraph.V1.Connection.delete!/3","type":"function","doc":"Perform a DELETE request. See request!/1 or request!/2 for options definition. delete!(&quot;/users&quot;) delete!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete!(client, &quot;/users&quot;) delete!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#execute/2","title":"GoogleApi.HomeGraph.V1.Connection.execute/2","type":"function","doc":"Execute a request on this connection Returns {:ok, Tesla.Env.t} - If the call was successful {:error, reason} - If the call failed"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#get/3","title":"GoogleApi.HomeGraph.V1.Connection.get/3","type":"function","doc":"Perform a GET request. See request/1 or request/2 for options definition. get(&quot;/users&quot;) get(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get(client, &quot;/users&quot;) get(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#get!/3","title":"GoogleApi.HomeGraph.V1.Connection.get!/3","type":"function","doc":"Perform a GET request. See request!/1 or request!/2 for options definition. get!(&quot;/users&quot;) get!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get!(client, &quot;/users&quot;) get!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#head/3","title":"GoogleApi.HomeGraph.V1.Connection.head/3","type":"function","doc":"Perform a HEAD request. See request/1 or request/2 for options definition. head(&quot;/users&quot;) head(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head(client, &quot;/users&quot;) head(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#head!/3","title":"GoogleApi.HomeGraph.V1.Connection.head!/3","type":"function","doc":"Perform a HEAD request. See request!/1 or request!/2 for options definition. head!(&quot;/users&quot;) head!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head!(client, &quot;/users&quot;) head!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#new/0","title":"GoogleApi.HomeGraph.V1.Connection.new/0","type":"function","doc":"Configure an authless client connection Returns Tesla.Env.client"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#new/1","title":"GoogleApi.HomeGraph.V1.Connection.new/1","type":"function","doc":"Configure a client connection using a function which yields a Bearer token. Parameters token_fetcher (type: list(String.t()) -&gt; String.t()) - Callback which provides an OAuth2 token given a list of scopes Returns Tesla.Env.client"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#options/3","title":"GoogleApi.HomeGraph.V1.Connection.options/3","type":"function","doc":"Perform a OPTIONS request. See request/1 or request/2 for options definition. options(&quot;/users&quot;) options(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options(client, &quot;/users&quot;) options(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#options!/3","title":"GoogleApi.HomeGraph.V1.Connection.options!/3","type":"function","doc":"Perform a OPTIONS request. See request!/1 or request!/2 for options definition. options!(&quot;/users&quot;) options!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options!(client, &quot;/users&quot;) options!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#patch/4","title":"GoogleApi.HomeGraph.V1.Connection.patch/4","type":"function","doc":"Perform a PATCH request. See request/1 or request/2 for options definition. patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#patch!/4","title":"GoogleApi.HomeGraph.V1.Connection.patch!/4","type":"function","doc":"Perform a PATCH request. See request!/1 or request!/2 for options definition. patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#post/4","title":"GoogleApi.HomeGraph.V1.Connection.post/4","type":"function","doc":"Perform a POST request. See request/1 or request/2 for options definition. post(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#post!/4","title":"GoogleApi.HomeGraph.V1.Connection.post!/4","type":"function","doc":"Perform a POST request. See request!/1 or request!/2 for options definition. post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#put/4","title":"GoogleApi.HomeGraph.V1.Connection.put/4","type":"function","doc":"Perform a PUT request. See request/1 or request/2 for options definition. put(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#put!/4","title":"GoogleApi.HomeGraph.V1.Connection.put!/4","type":"function","doc":"Perform a PUT request. See request!/1 or request!/2 for options definition. put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#request/2","title":"GoogleApi.HomeGraph.V1.Connection.request/2","type":"function","doc":"Perform a request Options: :method - the request method, one of [:head, :get, :delete, :trace, :options, :post, :put, :patch] :url - either full url e.g. &quot;http://example.com/some/path&quot; or just &quot;/some/path&quot; if using Tesla.Middleware.BaseUrl :query - a keyword list of query params, e.g. [page: 1, per_page: 100] :headers - a keyworld list of headers, e.g. [{&quot;content-type&quot;, &quot;text/plain&quot;}] :body - depends on used middleware: by default it can be a binary if using e.g. JSON encoding middleware it can be a nested map if adapter supports it it can be a Stream with any of the above :opts - custom, per-request middleware or adapter options Examples: ExampleApi.request(method: :get, url: &quot;/users/path&quot;) You can also use shortcut methods like: ExampleApi.get(&quot;/users/1&quot;) or ExampleApi.post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;})"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#request!/2","title":"GoogleApi.HomeGraph.V1.Connection.request!/2","type":"function","doc":"Perform request and raise in case of error. This is similar to request/2 behaviour from Tesla 0.x See request/2 for list of available options."},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#trace/3","title":"GoogleApi.HomeGraph.V1.Connection.trace/3","type":"function","doc":"Perform a TRACE request. See request/1 or request/2 for options definition. trace(&quot;/users&quot;) trace(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace(client, &quot;/users&quot;) trace(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#trace!/3","title":"GoogleApi.HomeGraph.V1.Connection.trace!/3","type":"function","doc":"Perform a TRACE request. See request!/1 or request!/2 for options definition. trace!(&quot;/users&quot;) trace!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace!(client, &quot;/users&quot;) trace!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#t:option/0","title":"GoogleApi.HomeGraph.V1.Connection.option/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Connection.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Connection.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId.html","title":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId","type":"module","doc":"Third-party partner&#39;s device ID for one device. Attributes id (type: String.t, default: nil) - Third-party partner&#39;s device ID."},{"ref":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.AgentDeviceId.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.html","title":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId","type":"module","doc":"Identifies a device in the third party or first party system. Attributes agentId (type: String.t, default: nil) - The agent&#39;s ID. Generally it is the agent&#39;s AoG project id. deviceId (type: String.t, default: nil) - Device ID defined by the agent. The device_id must be unique."},{"ref":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.Device.html","title":"GoogleApi.HomeGraph.V1.Model.Device","type":"module","doc":"Third-party partner&#39;s device definition. Attributes attributes (type: map(), default: nil) - Attributes for the traits supported by the device. customData (type: map(), default: nil) - Custom JSON data provided by the manufacturer and attached to QUERY and EXECUTE requests in AoG. deviceInfo (type: GoogleApi.HomeGraph.V1.Model.DeviceInfo.t, default: nil) - Device manufacturer, model, hardware version, and software version. id (type: String.t, default: nil) - Third-party partner&#39;s device ID. name (type: GoogleApi.HomeGraph.V1.Model.DeviceNames.t, default: nil) - Name of the device given by the third party. This includes names given to the device via third party device manufacturer&#39;s app, model names for the device, etc. notificationSupportedByAgent (type: boolean(), default: nil) - Indicates whether the device is capable of sending notifications. This field will be set by the agent (partner) on an incoming SYNC. If a device is not capable of generating notifications, the partner should set this flag to false. If a partner is not capable of calling ReportStateAndNotification to send notifications to Google, the partner should set this flag to false. If there is a user setting in the partner app to enable notifications and it is turned off, the partner should set this flag to false. otherDeviceIds (type: list(GoogleApi.HomeGraph.V1.Model.AgentOtherDeviceId.t), default: nil) - IDs of other devices associated with this device. This is used to represent a device group (e.g. bonded zone) or &quot;facets&quot; synced through different flows (e.g. Google Nest Hub Max with a Nest Camera). This may also be used to pass in alternate IDs used to identify a cloud synced device for local execution (i.e. local verification). If used for local verification, this field is synced from the cloud. roomHint (type: String.t, default: nil) - If the third-party partner&#39;s cloud configuration includes placing devices in rooms, the name of the room can be provided here. structureHint (type: String.t, default: nil) - As in roomHint, for structures that users set up in the partner&#39;s system. traits (type: list(String.t), default: nil) - Traits supported by the device. type (type: String.t, default: nil) - Hardware type of the device (e.g. light, outlet, etc). willReportState (type: boolean(), default: nil) - Indicates whether the state of this device is being reported to Google through ReportStateAndNotification call."},{"ref":"GoogleApi.HomeGraph.V1.Model.Device.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.Device.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.Device.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.Device.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.DeviceInfo.html","title":"GoogleApi.HomeGraph.V1.Model.DeviceInfo","type":"module","doc":"Device information. Attributes hwVersion (type: String.t, default: nil) - Device hardware version. manufacturer (type: String.t, default: nil) - Device manufacturer. model (type: String.t, default: nil) - Device model. swVersion (type: String.t, default: nil) - Device software version."},{"ref":"GoogleApi.HomeGraph.V1.Model.DeviceInfo.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.DeviceInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.DeviceInfo.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.DeviceInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.DeviceNames.html","title":"GoogleApi.HomeGraph.V1.Model.DeviceNames","type":"module","doc":"Different names for the device. Attributes defaultNames (type: list(String.t), default: nil) - List of names provided by the partner rather than the user, often manufacturer names, SKUs, etc. name (type: String.t, default: nil) - Primary name of the device, generally provided by the user. nicknames (type: list(String.t), default: nil) - Additional names provided by the user for the device."},{"ref":"GoogleApi.HomeGraph.V1.Model.DeviceNames.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.DeviceNames.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.DeviceNames.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.DeviceNames.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.Empty.html","title":"GoogleApi.HomeGraph.V1.Model.Empty","type":"module","doc":"A generic empty message that you can re-use to avoid defining duplicated empty messages in your APIs. A typical example is to use it as the request or the response type of an API method. For instance: service Foo { rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty); } The JSON representation for Empty is empty JSON object {}. Attributes"},{"ref":"GoogleApi.HomeGraph.V1.Model.Empty.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.Empty.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.Empty.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.Empty.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryRequest.html","title":"GoogleApi.HomeGraph.V1.Model.QueryRequest","type":"module","doc":"Request type for the Query call. This should be the same format as the Actions on Google action.devices.QUERY request with the exception of the extra agent_user_id and no intent and customData fields. Attributes agentUserId (type: String.t, default: nil) - Required. Third-party user ID. inputs (type: list(GoogleApi.HomeGraph.V1.Model.QueryRequestInput.t), default: nil) - Required. Inputs containing third-party partner&#39;s device IDs for which to get the device states. requestId (type: String.t, default: nil) - Request ID used for debugging."},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryRequest.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.QueryRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryRequest.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.QueryRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput.html","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput","type":"module","doc":"Device ID inputs to QueryRequest. Attributes payload (type: GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.t, default: nil) - Payload containing third-party partner&#39;s device IDs."},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestInput.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.html","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload","type":"module","doc":"Payload containing device IDs. Attributes devices (type: list(GoogleApi.HomeGraph.V1.Model.AgentDeviceId.t), default: nil) - Third-party partner&#39;s device IDs for which to get the device states."},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.QueryRequestPayload.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryResponse.html","title":"GoogleApi.HomeGraph.V1.Model.QueryResponse","type":"module","doc":"Response type for the Query call. This should follow the same format as the Actions on Google action.devices.QUERY response. Example { &quot;requestId&quot;: &quot;ff36a3cc-ec34-11e6-b1a0-64510650abcf&quot;, &quot;payload&quot;: { &quot;devices&quot;: { &quot;123&quot;: { &quot;on&quot;: true, &quot;online&quot;: true }, &quot;456&quot;: { &quot;on&quot;: true, &quot;online&quot;: true, &quot;brightness&quot;: 80, &quot;color&quot;: { &quot;name&quot;: &quot;cerulean&quot;, &quot;spectrumRGB&quot;: 31655 } } } } } Attributes payload (type: GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.t, default: nil) - Device states for the devices given in the request. requestId (type: String.t, default: nil) - Request ID used for debugging. Copied from the request."},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryResponse.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.QueryResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryResponse.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.QueryResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.html","title":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload","type":"module","doc":"Payload containing device states information. Attributes devices (type: map(), default: nil) - States of the devices. Map of third-party device ID to struct of device states."},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.QueryResponsePayload.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.html","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice","type":"module","doc":"The states and notifications specific to a device. Attributes notifications (type: map(), default: nil) - Notifications metadata for devices. states (type: map(), default: nil) - States of devices to update."},{"ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.html","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest","type":"module","doc":"Request type for the ReportStateAndNotification call. It may include States, Notifications, or both. This request uses globally unique flattened state names instead of namespaces based on traits to align with the existing QUERY and EXECUTE APIs implemented by 90+ Smart Home partners. States and notifications are defined per device_id (for example, &quot;123&quot; and &quot;456&quot; in the following example). # Example { &quot;requestId&quot;: &quot;ff36a3cc-ec34-11e6-b1a0-64510650abcf&quot;, &quot;agentUserId&quot;: &quot;1234&quot;, &quot;payload&quot;: { &quot;devices&quot;: { &quot;states&quot;: { &quot;123&quot;: { &quot;on&quot;: true }, &quot;456&quot;: { &quot;on&quot;: true, &quot;brightness&quot;: 10 } }, } } } Attributes agentUserId (type: String.t, default: nil) - Required. Third-party user ID. eventId (type: String.t, default: nil) - Unique identifier per event (for example, a doorbell press). followUpToken (type: String.t, default: nil) - Token to maintain state in the follow up notification response. payload (type: GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.t, default: nil) - State of devices to update and notification metadata for devices. For example, if a user turns a light on manually, a state update should be sent so that the information is always the current status of the device. Notifications are independent from the state and its piece of the payload should contain everything necessary to notify the user. Although it may be related to a state change, it does not need to be. For example, if a device can turn on/off and change temperature, the states reported would include both &quot;on&quot; and &quot;70 degrees&quot; but the 3p may choose not to send any notification for that, or to only say that the &quot;the room is heating up&quot;, keeping state and notification independent. requestId (type: String.t, default: nil) - Request ID used for debugging."},{"ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse.html","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse","type":"module","doc":"Response type for the ReportStateAndNotification call. Attributes requestId (type: String.t, default: nil) - Request ID copied from ReportStateAndNotificationRequest."},{"ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.html","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest","type":"module","doc":"Request type for the RequestSyncDevices call. Attributes agentUserId (type: String.t, default: nil) - Required. Third-party user ID issued by agent&#39;s third-party identity provider. async (type: boolean(), default: nil) - Optional. If set, the request will be added to a queue and a response will be returned immediately. The queue allows for de-duplication of simultaneous requests."},{"ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse.html","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse","type":"module","doc":"Response type for the RequestSyncDevices call. Intentionally empty upon success. An HTTP response code is returned with more details upon failure. Attributes"},{"ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.RequestSyncDevicesResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.html","title":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload","type":"module","doc":"Payload containing the state and notification information for devices. Attributes devices (type: GoogleApi.HomeGraph.V1.Model.ReportStateAndNotificationDevice.t, default: nil) - The devices for updating state and sending notifications."},{"ref":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.StateAndNotificationPayload.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.SyncRequest.html","title":"GoogleApi.HomeGraph.V1.Model.SyncRequest","type":"module","doc":"Request type for the Sync call. This should follow the same format as the Actions on Google action.devices.SYNC request with the exception of the extra agent_user_id and no intent field. Attributes agentUserId (type: String.t, default: nil) - Required. Third-party user ID. requestId (type: String.t, default: nil) - Request ID used for debugging."},{"ref":"GoogleApi.HomeGraph.V1.Model.SyncRequest.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.SyncRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.SyncRequest.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.SyncRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.SyncResponse.html","title":"GoogleApi.HomeGraph.V1.Model.SyncResponse","type":"module","doc":"Response type for the Sync call. This should follow the same format as the Actions on Google action.devices.SYNC response. Example { &quot;requestId&quot;: &quot;ff36a3cc-ec34-11e6-b1a0-64510650abcf&quot;, &quot;payload&quot;: { &quot;agentUserId&quot;: &quot;1836.15267389&quot;, &quot;devices&quot;: [{ &quot;id&quot;: &quot;123&quot;, &quot;type&quot;: &quot;action.devices.types.OUTLET&quot;, &quot;traits&quot;: [ &quot;action.devices.traits.OnOff&quot; ], &quot;name&quot;: { &quot;defaultNames&quot;: [&quot;My Outlet 1234&quot;], &quot;name&quot;: &quot;Night light&quot;, &quot;nicknames&quot;: [&quot;wall plug&quot;] }, &quot;willReportState&quot;: false, &quot;deviceInfo&quot;: { &quot;manufacturer&quot;: &quot;lights-out-inc&quot;, &quot;model&quot;: &quot;hs1234&quot;, &quot;hwVersion&quot;: &quot;3.2&quot;, &quot;swVersion&quot;: &quot;11.4&quot; }, &quot;customData&quot;: { &quot;fooValue&quot;: 74, &quot;barValue&quot;: true, &quot;bazValue&quot;: &quot;foo&quot; } }] } } Attributes payload (type: GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.t, default: nil) - Devices associated with the third-party user. requestId (type: String.t, default: nil) - Request ID used for debugging. Copied from the request."},{"ref":"GoogleApi.HomeGraph.V1.Model.SyncResponse.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.SyncResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.SyncResponse.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.SyncResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.html","title":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload","type":"module","doc":"Payload containing device information. Attributes agentUserId (type: String.t, default: nil) - Third-party user ID devices (type: list(GoogleApi.HomeGraph.V1.Model.Device.t), default: nil) - Devices associated with the third-party user."},{"ref":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.html#decode/2","title":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.html#t:t/0","title":"GoogleApi.HomeGraph.V1.Model.SyncResponsePayload.t/0","type":"type","doc":""}]